﻿using System;
using System.ComponentModel;
using System.Windows.Forms;

namespace Spread_AutoFill_Handle
{
    public partial class Form1 : Form
    {
        //Contex Menu Strip corresponding to Autofill Handle in Excel
        ContextMenuStrip Autofill_Handle_ContextMenu;
        ToolStripMenuItem fillFormulasToolStripMenuItem;
        int rowbegin, columnbegin;
        string direction;
        public Form1()
        {
            InitializeComponent();
            this.Autofill_Handle_ContextMenu = new System.Windows.Forms.ContextMenuStrip();
            this.fillFormulasToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            // 
            // fillSeriesToolStripMenuItem
            // 
            this.fillFormulasToolStripMenuItem.Size = new System.Drawing.Size(231, 24);
            this.fillFormulasToolStripMenuItem.Text = "Fill Formulas";
            Autofill_Handle_ContextMenu.Items.Add(fillFormulasToolStripMenuItem);
            this.fillFormulasToolStripMenuItem.Click += new System.EventHandler(this.fillFormulasToolStripMenuItem_Click);
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            fpSpread1.DragFillBlock += new FarPoint.Win.Spread.DragFillBlockEventHandler(fpSpread1_DragFillBlock);
            fpSpread1.DragFillBlockCompleted += new FarPoint.Win.Spread.DragFillBlockCompletedEventHandler(fpSpread1_DragFillBlockCompleted);
            Autofill_Handle_ContextMenu.Opening += new CancelEventHandler(Autofill_Handle_ContextMenu_Opening);
            // Allowing drag and fill for spread
            fpSpread1.AllowDragFill = true;
            fpSpread1.AllowUserFormulas = true;

            fpSpread1.Sheets[0].Cells[0, 0].Formula = "28+23";
        }
        void Autofill_Handle_ContextMenu_Opening(object sender, CancelEventArgs e)
        {
            // to disable the Menustrip if no cell is dragging is performed
            if (fpSpread1.ActiveSheet.GetSelection(0).ColumnCount == 1 && fpSpread1.ActiveSheet.GetSelection(0).RowCount == 1)
            {
                e.Cancel = true;
            }
        }
        void fpSpread1_DragFillBlockCompleted(object sender, FarPoint.Win.Spread.DragFillBlockCompletedEventArgs e)
        {
             rowbegin = e.RowBegin;
             columnbegin = e.ColumnBegin;
             direction = e.Direction.ToString();
        }
        void fpSpread1_DragFillBlock(object sender, FarPoint.Win.Spread.DragFillBlockEventArgs e)
        {
            fpSpread1.ContextMenuStrip = Autofill_Handle_ContextMenu;
        }
        private void fillFormulasToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Fill Series i.e. Auto Increment/Decrement
            int num = Convert.ToInt32(fpSpread1.ActiveSheet.Cells[rowbegin, columnbegin].Value);
            int j = 1;
            if (direction == "Down")
            {
                for (int i = rowbegin + 1; i < (fpSpread1.ActiveSheet.GetSelection(0).RowCount + rowbegin); i++)
                {
                    fpSpread1.ActiveSheet.Cells[i, columnbegin].Formula = fpSpread1.ActiveSheet.Cells[rowbegin, columnbegin].Formula;
                    ++j;
                }
            }

            else if (direction == "Up")
            {
                for (int i = rowbegin - 1; i > (rowbegin - fpSpread1.ActiveSheet.GetSelection(0).RowCount); i--)
                {
                    fpSpread1.ActiveSheet.Cells[i, columnbegin].Formula = fpSpread1.ActiveSheet.Cells[rowbegin, columnbegin].Formula;
                    ++j;
                }
            }

            else if (direction == "Right")
            {
                for (int i = columnbegin + 1; i < (fpSpread1.ActiveSheet.GetSelection(0).ColumnCount + columnbegin); i++)
                {
                    fpSpread1.ActiveSheet.Cells[rowbegin, i].Formula = fpSpread1.ActiveSheet.Cells[rowbegin, columnbegin].Formula;
                    ++j;
                }
            }

            else if (direction == "Left")
            {
                for (int i = columnbegin - 1; i > (columnbegin   - fpSpread1.ActiveSheet.GetSelection(0).ColumnCount); i--)
                {
                    fpSpread1.ActiveSheet.Cells[rowbegin, i].Formula = fpSpread1.ActiveSheet.Cells[rowbegin, columnbegin].Formula;
                    ++j;
                }
            }
        }
    }
}
